#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

int main() {
    int n, k;
    cin >> n >> k;
    vector<ll> v(n + 1);
    vector<ll> prefsum(n + 1, 0);
    int msize = n - k + 1;
    vector<ll> lmin(n + 1, 0);
    vector<ll> rmin(n + 1, 0);

    prefsum[0] = 0;
    lmin[0] = LONG_LONG_MAX;
    rmin[n] = LONG_LONG_MAX;

    for (int i = 1; i <= n; i++) {
        ll a;
        cin >> a;
        prefsum[i] = prefsum[i - 1] + a;
        lmin[i] = min(lmin[i - 1], a);
        v[i] = a;
    }
    for (int i = n - 1; i >= 0; i--) {
        rmin[i] = min(rmin[i + 1], v[i + 1]);
    }

    ll maxans = 0;

    int l = 1, r = msize;
    while (r <= n) {
        maxans = max(maxans, prefsum[r] - prefsum[l - 1] - min(lmin[l - 1], rmin[r]));
        l++;
        r++;
    }
    cout << maxans << endl;
}

// 5 2 2 1 3 4 1