#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

int main() {
    ll n, s;
    cin >> n >> s;
    vector<vector<int> > tasks(n + 1);
    int from_1 = 0;
    bool is_task4 = true;
    for (ll i = 0; i < n; i++) {
        int a;
        cin >> a;
        if (a == 1) {
            int b;
            cin >> b;
            from_1 += b;
            tasks[i + 1].push_back(b);
            continue;
        }
        for (ll j = 0; j < a; j++) {
            is_task4 = false;
            int b;
            cin >> b;
            tasks[i + 1].push_back(b);
        }
    }

    if (s - from_1 < 0) {
        cout << "No" << endl;
        return 0;
    }
    if (s - from_1 == 0) {
        if (is_task4) {
            cout << "Yes" << endl;
            for (ll i = 0; i < n; i++) {
                cout << 1 << endl;
                cout << 1 << endl;
            }
            return 0;
        } else {
            cout << "No" << endl;
            return 0;
        }
    }
    if (is_task4) {
        cout << "No" << endl;
        return 0;
    }

    vector<vector<int> > dp(n + 1, vector<int>(s + 5, -1));
    dp[0][0] = 0;
    for (int i = 1; i <= n; i++) {
        for (int j = 0; j < s + 5; j++) {
            for (int podz = tasks[i].size() - 1; podz >= 0; podz--) {
                if (j >= tasks[i][podz] && dp[i][j - tasks[i][podz]] != -1) {
                    dp[i][j] = podz;
                } else if (dp[i - 1][j - tasks[i][podz]] != -1 && dp[i - 1][j] + tasks[i][podz] <= s) {
                    dp[i][j] = podz;
                }
            }
        }
    }

    vector<vector<int> > ans(n + 1, vector<int>());
    if (dp[n][s] != -1) {
        int x = n, y = s;
        while (x != 0 && y != 0) {
            ans[x].push_back(dp[x][y] + 1);
            if (dp[x - 1][y - tasks[x][dp[x][y]]] != -1) {
                y -= tasks[x][dp[x][y]];
                x--;
            } else {
                y -= tasks[x][dp[x][y]];
            }
        }
        for (vector<int> v : ans) {
            cout << v.size() << endl;
            for (auto i : v) {
                cout << i << endl;
            }
        }
    } else {
        cout << "No" << endl;
    }
}

// 2 4 1 2 2 3 1
// 2 4 1 2 2 2 1
